<template>
    <div ref="editeur" />
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Quill from 'quill';
import { Prop } from 'vue-property-decorator';

@Component
export default class EditeurTexte extends Vue {
    @Prop() value: string;
    private editeur;

    mounted() {
        this.editeur = new Quill(this.$refs.editeur, {
            modules: {
                toolbar: [
                    [{ header: [1, 2, 3, 4, false] }],
                    ['bold', 'italic', 'underline']
                ]
            },
            theme: 'snow',
            formats: ['bold', 'underline', 'header', 'italic']
        });
        this.editeur.root.innerHTML = this.value;
        // We will add the update event here
        this.editeur.on('text-change', () => {
            this.mettreAJourTexte();
        });
    }

    mettreAJourTexte() {
        this.$emit(
            'input',
            this.editeur.getText() ? this.editeur.root.innerHTML : ''
        );
    }
}
</script>

<style lang="css" scoped>
@import 'https://cdn.quilljs.com/1.3.6/quill.snow.css';
</style>
